const NOTIFY_STATE_DOCUMENT =
  Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT; 

var SpurlPref = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('spurlbar.settings.');
// The Global Sidebar Object
var mysidebar;
function getSideBar() {
	if (!mysidebar) {
		mysidebar = top.document.getElementById('sidebar').contentWindow;
	}
	return mysidebar;
}


function LoadSpurl(currentLocation, currentTitle) {
	var SpurlSideUrl = 'http://www.spurl.net/spurlbar1.php';
	var browser=getSideBar().document.getElementById("spurlBrowser");
	browser.webNavigation.loadURI(SpurlSideUrl,0,null,null,null);
}

function clicked (event) {
	// quit if button is not 1 (middle click)
	if (event.button != 1) return;
	if (event.target.tagName == "A") {
		if (event.target.href) {
			top.window.openNewTabWith(event.target.href,null,null,true);
		}
	}

}

// This function is called right when the sidebar is opened
function onLoadSpurlPanel() {
	if (SpurlPref.prefHasUserValue ('spurl_static')) {
		if (SpurlPref.getBoolPref ('spurl_static')) {
			if (SpurlPref.prefHasUserValue ('spurl_width')) {
				var sidebar_width = SpurlPref.getCharPref('spurl_width');
				sidebar_width = sidebar_width.concat('px');
				top.document.getElementById('sidebar-box').width=sidebar_width;
			} else {
				top.document.getElementById('sidebar-box').width="213px";
			}
		}
	}
	LoadSpurl(window.top._content.location.href, window.top._content.document.title);
	if (document.getElementById("spurlContextMenu")){
        document.getElementById("spurlContextMenu").addEventListener("popupshowing",OnPopup,false);
   }
   document.getElementById("spurlBrowser").addProgressListener(nsBrowserStatusHandler,Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
   top.document.getElementById("sidebar-throbber").setAttribute("loading",true);
   }
var nsBrowserStatusHandler = {
	QueryInterface: function(aIID)
   {
      if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
          aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
          aIID.equals(Components.interfaces.nsISupports))
      return this;
      throw Components.results.NS_NOINTERFACE;
   }, 
	onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus) {
		const nsIWebProgressListener = Components.interfaces.nsIWebProgressListener;    
		const nsIChannel = Components.interfaces.nsIChannel;
		const STATE_STOP = Components.interfaces.nsIWebProgressListener.STATE_STOP; 
		const STATE_START = Components.interfaces.nsIWebProgressListener.STATE_START; 
		const STATE_IS_WINDOW = Components.interfaces.nsIWebProgressListener.STATE_IS_WINDOW; 
		const STATE_IS_REQUEST = Components.interfaces.nsIWebProgressListener.STATE_IS_REQUEST; 
		const STATE_IS_NETWORK = Components.interfaces.nsIWebProgressListener.STATE_IS_NETWORK;
        
		if (aStateFlags & STATE_IS_NETWORK && aStateFlags & STATE_START) {
			top.document.getElementById("sidebar-throbber").setAttribute("loading",true);
		}
		if (aStateFlags  == (STATE_IS_WINDOW|STATE_IS_NETWORK|STATE_STOP)) {
			top.document.getElementById("sidebar-throbber").removeAttribute("loading");
   		} 
		return 0;
	},
   onLocationChange: function(aProgress, aRequest, aURI)  { return 0; },
   onProgressChange: function() {return 0;},
   onStatusChange: function() {return 0;},
   onSecurityChange: function() {return 0;},
   onLinkIconAvailable: function() {return 0;} 
}
function openPart (part) { 
	if (part == "MySpurls") 
		top.window.loadURI("http://www.spurl.net/myspurls/",null,null,null);
	if (part == "Export") 
		top.window.loadURI("http://www.spurl.net/myspurls/export.php",null,null,null);
	if (part == "Streams")
		top.window.loadURI("http://stream.spurl.net",null,null,null);
	if (part == "Forum")
		top.window.loadURI("http://www.spurl.net/help/forum/",null,null,null);
		
}
function SideBarClose() {
	top.toggleSidebar();
	top.togglespurlbar-button(!spurlbar-button.checked);
}
function OnPopup () {
	var elem = node = document.popupNode;
    var selection = "";
    var nodeLocalName = node.localName.toUpperCase();
    var item1=document.getElementById("spurlnewtab");
	var item2=document.getElementById("spurlopencache");
	var item3=document.getElementById("spurlcopylink");
/*	var idmiz="i"+node.id.substring(1);
	var idhref=node.ownerDocument.getElementById(idmiz).parentNode.href;
	var index = idhref.indexOf('id=')+3;
	idmiz = idhref.substring(index);

	while (elem) {
		if (elem.localName.toUpperCase() == 'A') {
			alert (elem.href);
		}
		elem = elem.parentNode;
	}
*/
	if (nodeLocalName != "A") {
		item1.hidden = item2.hidden = item3.hidden = true;
    } else {
//		alert(idmiz);
		item1.hidden = item2.hidden = item3.hidden = false;
	}
}
function OpenCache() {
    var node = document.popupNode;
    var selection = "http://cache.spurl.net/?url=";
    var nodeLocalName = node.localName.toUpperCase();
    
	if (nodeLocalName == "A") {
    	selection = selection.concat(escape(node.href));
    } 
	top.window._content.location.href = selection;
}

function OpenInNewTab() {
    var node = document.popupNode;
    var selection = "";
    var nodeLocalName = node.localName.toUpperCase();
    if (nodeLocalName == "A") {
        selection = node.href;
    } 
	top.window.openNewTabWith(selection,null,null,true);
}

function copyLink () {
        var clipboard = Components.classes['@mozilla.org/widget/clipboardhelper;1'].getService(Components.interfaces.nsIClipboardHelper );
        clipboard.copyString(document.popupNode.href);
}
